/**
 * 填写个人信息
 */
define("project/scripts/account/personInfo", function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		manId = "",
		womenId = "",
		validatorUtil = require("validatorUtil"),
		idCardModify = false, // 身份证是否被手工修改
		_pageId = "#account_personInfo";
	var	page_Id = "#credit_record";
	var control_person = "";
	var benefit_person = "";
	var credit_recordStr = "";
	var credit_record = "";
	var isAgreementCommission=true;
	var $page = $(_pageId);
	var check_val = "";
	var check_val_str = "";
	var provincename = "";
	var cityname = " ";
	var areaname = "";
    var provinceTemp = "";
    var cityTemp = " ";
    var areaTemp = "";
	/* 私有业务模块的全局变量 end */

	function init() {
		layerUtils.iLoading(true);
		$(_pageId+" .header:eq(0)").show();
		$(_pageId+" .main:eq(0)").show();
		$(_pageId+" .fix_bot").show();
		 //从视频见证页面驳回跳转过来
	    var personinfoFlag = appUtils.getPageParam("personinfoFlag");
	    var personinfo = appUtils.getSStorageInfo("personinfoFlag");
	    personinfo = JSON.parse(personinfo);
	    if(personinfoFlag== "SYS:10012"|| personinfo.need_personInfo ==1){
	    	$(".icon_back",_pageId).hide();
	    }
	
		cleanPageElement(); // 清除页面元素 
		window.calendarCallback = calendarCallback; // 全局调用日期插件方法
		//  从上传照片页面进入
		if(appUtils.getSStorageInfo("_prePageCode") == "account/uploadPhoto" || appUtils.getSStorageInfo("_prePageCode") == "account/uploadPhotoChange") {
			// 根据传入的值，填充页面的数据
			$(_pageId + " .name").val(appUtils.getPageParam("custname")); // 客户姓名
			if(appUtils.getPageParam("ethnicname") != "" || appUtils.getPageParam("ethnicname") != null || appUtils.getPageParam("ethnicname") != undefined){
				$(_pageId + " .ethnicname").val(appUtils.getPageParam("ethnicname")); //民族
			}else{
				$(_pageId + " .ethnicname").val("汉族"); //民族
			}
            $(_pageId+" .icon_check").removeClass("checked");
			$(_pageId + " .idCardNo").val(appUtils.getPageParam("idno")); // 身份证号
			$(_pageId + " .signDepartment").val(appUtils.getPageParam("policeorg")); // 签发机关
			$(_pageId + " .idCardAddress").val(appUtils.getPageParam("native")); // 证件地址
			
			/*provincename = appUtils.getSStorageInfo("province");//联系地址省份
			cityname = appUtils.getSStorageInfo("city");//联系地址市
			areaname = appUtils.getSStorageInfo("area");//联系地址区
			if(provincename != "" && cityname != "" && areaname != "" && provincename != null && cityname != null && areaname != null){
				$(_pageId + " .address").text(provincename+cityname+areaname); // 联系地址和证件地址设置相同的
			}else{
				$(_pageId + " .address").text(provincename+areaname); // 联系地址和证件地址设置相同的
			}
			
			var addresss = appUtils.getSStorageInfo("addr");
			if(addresss != "" || addresss != null || addresss != undefined){
				$(_pageId + " .address_text").val(addresss); // 联系地址和证件地址设置相同的
			}*/
			
			$(_pageId + " .idBeginDate").val(appUtils.getPageParam("idbegindate")); //起始期限
			if(appUtils.getPageParam("idenddate") == "3000-12-31"){
				$(_pageId + " .idEndDate").val("长期"); //结束期限
				$(_pageId+" .icon_check").addClass("checked");
			}else{
				$(_pageId + " .idEndDate").val(appUtils.getPageParam("idenddate")); //结束期限
			}
			$(_pageId + " .zipCode").val(appUtils.getPageParam("postid")); //邮编
			$(_pageId + " .workUnit").val(appUtils.getSStorageInfo("workplace"));//工作单位
			$(_pageId + " .mailbox").val(appUtils.getSStorageInfo("email"));//邮箱
			control_person = $(_pageId + " .name").val(); 
			benefit_person = $(_pageId + " .name").val();
            provincename = appUtils.getSStorageInfo("province");//联系地址省份
            cityname = appUtils.getSStorageInfo("city");//联系地址市
            areaname = appUtils.getSStorageInfo("area");//联系地址区
            //回显联系地址
            var addressText = (provincename||"") + (cityname|| "") + (areaname||"");
            $(_pageId + " .address").text(addressText || "请选择省市区");
            var addresss = appUtils.getSStorageInfo("addr");
            if(addresss != "" || addresss != null || addresss != undefined){
                $(_pageId + " .address_text").val(addresss); // 联系地址和证件地址设置相同的
            }
		}else{
		   $(_pageId + " .name").val(appUtils.getSStorageInfo("custname")); // 客户姓名
			$(_pageId + " .ethnicname").val(appUtils.getSStorageInfo("ethnicname")); //民族
			$(_pageId + " .idCardNo").val(appUtils.getSStorageInfo("idCardNo")); // 身份证号
			$(_pageId + " .signDepartment").val(appUtils.getSStorageInfo("policeorg")); // 签发机关
			$(_pageId + " .idCardAddress").val(appUtils.getSStorageInfo("native")); // 证件地址
			
			provincename = appUtils.getSStorageInfo("province");//联系地址省份
			cityname = appUtils.getSStorageInfo("city");//联系地址市
			areaname = appUtils.getSStorageInfo("area");//联系地址区
            var addressText = (provincename||"") + (cityname|| "") + (areaname||"");
            $(_pageId + " .address").text(addressText || "请选择省市区");
			
			var addresss = appUtils.getSStorageInfo("addr");
			if(addresss != "" || addresss != null || addresss != undefined){
				$(_pageId + " .address_text").val(addresss); // 联系地址和证件地址设置相同的
			}
			
			$(_pageId + " .zipCode").val(appUtils.getSStorageInfo("postid")); //邮编
			$(_pageId + " .idBeginDate").val(appUtils.getSStorageInfo("idbegindate")); // 证件开始日期
			if(appUtils.getSStorageInfo("idenddate") == "3000-12-31"){
				$(_pageId + " .idEndDate").val("长期"); // 证件结束日期
				$(_pageId+" .icon_check").addClass("checked");
			}else{
				$(_pageId + " .idEndDate").val(appUtils.getSStorageInfo("idenddate")); // 证件结束日期
			}
			$(_pageId + " .workUnit").val(appUtils.getSStorageInfo("workplace"))//工作单位
			control_person = $(_pageId + " .name").val(); 
			benefit_person = $(_pageId + " .name").val(); 
			$(_pageId + " .mailbox").val(appUtils.getSStorageInfo("email"));//邮箱
		}
		queryDataDict(); // 获取职业和学历列表
		province();//获取省市区
	}

	function bindPageEvent() {
		/*切换结束日期是否为长期*/
		appUtils.bindEvent($(_pageId+" .icon_check"),function(){
			$(this).toggleClass("checked");
			if($(this).hasClass("checked")){
				$(_pageId + " .idEndDate").val("长期"); // 证件结束日期
			}else{
				if(appUtils.getSStorageInfo("_prePageCode") == "account/uploadPhoto" || appUtils.getSStorageInfo("_prePageCode") == "account/uploadPhotoChange"){
					$(_pageId + " .idEndDate").val(appUtils.getPageParam("idenddate")); //结束期限
				}else{
					$(_pageId + " .idEndDate").val(appUtils.getSStorageInfo("idenddate")); // 证件结束日期
				}
			}
		});
		/* 选择联系地址 */
		appUtils.bindEvent($(_pageId+" .address"),function(e){
			$(_pageId + " .address1 ul li").removeClass("active");
			// 显示选择联系地址的下拉列表
			$(_pageId + " .sel_list:eq(5)").slideDown("fast");
			$(_pageId + " #ad_province").show();
			$(_pageId + " #ad_city").hide();
			$(_pageId + " #ad_area").hide();
			e.stopPropagation(); // 阻止冒泡
		});
		
		//放弃开通
		appUtils.bindEvent($(_pageId+" #commitment .layer_btn a:eq(0)"),function(){
			isAgreementCommission=false;
			$(_pageId+" #commitment").hide();
			return;
		});
		
		//确定开通
		appUtils.bindEvent($(_pageId+" #commitment .layer_btn a:eq(1)"),function(){
			isAgreementCommission=true;
			$(_pageId+" #commitment").hide();
		});
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
			pageBack();
		});

		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId), function(e) {
			// 隐藏下拉列表
			$(_pageId + " .sel_list").slideUp("fast", function() {
//				$("body #bodyContent").css("overflow", "visible");
			});
			e.stopPropagation(); // 阻止冒泡
		});

		/* 选择职务*/
		appUtils.bindEvent($(_pageId + " .post"), function(e) {
			$(_pageId + " .postList ul li").removeClass("active");
			// 显示选择职业的下拉列表
			$(_pageId + " .sel_list:eq(4)").slideDown("fast", function() {
//				$("body #bodyContent").css("overflow", "hidden");
			});
			e.stopPropagation(); // 阻止冒泡
		});
		
		/* 选择职业 */
		appUtils.bindEvent($(_pageId + " .selectOccupation"), function(e) {
			$(_pageId + " .job ul li").removeClass("active");
			// 显示选择职业的下拉列表
			$(_pageId + " .sel_list:eq(0)").slideDown("fast", function() {
//				$("body #bodyContent").css("overflow", "hidden");
			});
			e.stopPropagation(); // 阻止冒泡
		});
		/* 选择学历 */
		appUtils.bindEvent($(_pageId + " .selectDegree"), function(e) {
			$(_pageId + " .education ul li").removeClass("active");
			// 显示选择学历的下拉列表
			$(_pageId + " .sel_list:eq(1)").slideDown("fast", function() {
//				$("body #bodyContent").css("overflow", "hidden");
			});
			e.stopPropagation(); // 阻止冒泡
		});
		/* 选择行业 */
		appUtils.bindEvent($page.find('.selectIndustry'), function(e) {
			$page.find('.industryList').slideDown('fast', function() {
//				$('#bodyContent').css('overflow', 'hidden');
			});
			e.stopPropagation();
		});
		/* 选择税收居民身份 */
		appUtils.bindEvent($page.find('.taxStatus'), function(e) {
			$page.find('.taxStatusList').slideDown('fast', function() {
//				$('#bodyContent').css('overflow', 'hidden');
			});
			e.stopPropagation();
		});
		/* 限制名字的长度 */
		appUtils.bindEvent($(_pageId + " .name"), function() {
			utils.dealIPhoneMaxLength(this, 8); //处理iphone兼容
		}, "input");

		/* 限制身份证的长度 */
		appUtils.bindEvent($(_pageId + " .idCardNo"), function() {
			utils.dealIPhoneMaxLength(this, 18); //处理iphone兼容
		}, "input");

		/* 限制邮编在IOS上的长度 */
		appUtils.bindEvent($(_pageId + " .zipCode"), function() {
			utils.dealIPhoneMaxLength(this, 6); //处理iphone兼容
			if(!validatorUtil.isNumeric($(this).val())) {
				layerUtils.iMsg(-1, "输入邮编号格式不对");
			}
		}, "input");

		/* 绑定选择日期的事件 */
		appUtils.bindEvent($(_pageId + " input[date-plugin='true']"), function(e) {
			utils.selectDate(this); // 通过壳子调用系统的日历插件 
		});

		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId + " .fix_bot .ct_btn"), function() {
			if(verifyInfo()) // 校验数据
			{
				submitInfo(); //提交用户信息
			}
		});
		
		/*绑定账户实际控制人按钮*/
		appUtils.bindEvent($(_pageId+" #actual_controller .text"),function(){
			if($(this).find("input").is(":checked")){
				$(this).find("input").prop("checked",false);
				layerUtils.iAlert("账户控制人非您本人,网上无法核实准确信息,请您临柜办理开户业务!",-1,function(){
				});
				control_person = "";
			}else{
				$(this).find("input").prop("checked",true);
				$(_pageId+" #actual_controller .text input").click();
				control_person = $(_pageId + " .user_form .name").val();
			}
		});
		/*绑定账户实际收益人按钮*/
		appUtils.bindEvent($(_pageId+" #actual_beneficiary .text"),function(){
			if($(this).find("input").is(":checked")){
				$(this).find("input").prop("checked",false);
				layerUtils.iAlert("账户受益人非您本人,网上无法核实准确信息,请您临柜办理开户业务!",-1,function(){
				});
				benefit_person = "";
			}else{
				$(this).find("input").prop("checked",true);
				$(_pageId+" #actual_beneficiary .text input").click();
				benefit_person = $(_pageId + " .user_form .name").val();
			}
			
		});
		/*绑定不良诚信记录按钮*/
		appUtils.bindEvent($(_pageId+" .credit_record"),function(){
			$(_pageId+" .header:eq(0)").hide();
			$(_pageId+" .main:eq(0)").hide();
			$(_pageId+" .header:eq(1)").show();
			$(_pageId+" .main:eq(1)").show();
			$(_pageId+" .fix_bot").hide();
		});
		/*绑定不良诚信记录里面的返回按钮*/
		appUtils.bindEvent($(_pageId+" #iconBack"),function(){
			$(_pageId+" .header:eq(0)").show();
			$(_pageId+" .main:eq(0)").show();
			$(_pageId+" .header:eq(1)").hide();
			$(_pageId+" .main:eq(1)").hide();
			$(_pageId+" .fix_bot").show();
		});
		/*绑定不良诚信记录里面的完成按钮*/
		appUtils.bindEvent($(_pageId + " #finish"),function(){
			credit_recordStr = "";
			check_val="";
			var count=0;
			$(_pageId + " .bg_gray .record_list:eq(1) p").each(function(){
				if($(this).hasClass("on")){
					count++;
				}
			});
			if(count==0){
				$(_pageId + " .bg_gray .record_list:eq(0) p").addClass("on");
			}
			if($(_pageId + " .bg_gray .record_list:eq(0) p").hasClass("on")){
				check_val_str = $(_pageId + " .bg_gray .record_list:eq(0) p").text();
				credit_record = $(_pageId + " .bg_gray .record_list:eq(0) p").attr("value");
				$(_pageId + " .credit_record").html(check_val_str);
			}else{
				$(_pageId + " .bg_gray .record_list:eq(1) p").each(function(){
					if($(this).hasClass("on")){
						credit_recordStr += $(this).attr("value")+",";
						check_val += $(this).text()+",";
					}
				});
				if(credit_recordStr!=""){
					credit_record = credit_recordStr.substring(0,credit_recordStr.length - 1);
				}
				if(check_val!=""){
					check_val_str = check_val.substring(0,check_val.length - 1);
				}
			}
			$(_pageId + " .credit_record").html(check_val_str);
			appUtils.setSStorageInfo("check_val_str",check_val_str);
			appUtils.setSStorageInfo("credit_record",credit_record);
			$(_pageId+" .header:eq(0)").show();
			$(_pageId+" .main:eq(0)").show();
			$(_pageId+" .header:eq(1)").hide();
			$(_pageId+" .main:eq(1)").hide();
			$(_pageId+" .fix_bot").show();
			$('div').animate({scrollTop: $("#account_personInfo").height()+'px'});
			
		});
	}

	/* 处理返回按钮 */
	function pageBack() {
			appUtils.pageInit("account/personInfo", "account/uploadPhoto", {});
	   }

	function destroy() {
		service.destroy();
	}

	/*提交开户信息*/
	function submitInfo() {	
		// 开户信息资料提交
		//从视频驳回处处理	
		var personinfoFlag = appUtils.getSStorageInfo("personinfoFlag");
	    var personinfoFlag = JSON.parse(personinfoFlag);
	    var personinfo = appUtils.getPageParam("personinfoFlag");
		var photoFlag = appUtils.getSStorageInfo("photoFlag");
	    var photoFlag = JSON.parse(photoFlag);
	    
		var param = setSubmitDataParam();
		service.submitUserInfo(param, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0) {
			    appUtils.setSStorageInfo("custname", $(_pageId + " .name").val().trim());//姓名
				appUtils.setSStorageInfo("idCardNo", $(_pageId + " .idCardNo").val());//身份证号
				appUtils.setSStorageInfo("native",$(_pageId + " .idCardAddress").val().replace(/\s+/g, ""));// 证件地址
			    appUtils.setSStorageInfo("province",provincename);//联系地址省份
				appUtils.setSStorageInfo("city",cityname);//联系地址市
				appUtils.setSStorageInfo("area",areaname);//联系地址区
				appUtils.setSStorageInfo("addr",$(_pageId + " .address_text").val().replace(/\s+/g, ""));//详细地址
			    appUtils.setSStorageInfo("idbegindate",  $(_pageId + " .idBeginDate").val());// 证件开始日期
				appUtils.setSStorageInfo("idenddate", $(_pageId + " .idEndDate").val()); // 证件结束日期
				appUtils.setSStorageInfo("postid", $(_pageId + " .zipCode").val()); // 邮政编码
				appUtils.setSStorageInfo("policeorg",$(_pageId + " .signDepartment").val()); // 签发机关
			    appUtils.setSStorageInfo("profession_code", $(_pageId + " .selectOccupation").attr("value"));// 职业代码
				appUtils.setSStorageInfo("edu", $(_pageId + " .selectDegree").attr("value"));// 学历代码
				appUtils.setSStorageInfo("occupation",$(_pageId + " .selectIndustry").attr("value")); //行业代码
			    appUtils.setSStorageInfo("recommendno", appUtils.getSStorageInfo("recommendno"));//推荐人号码
			    appUtils.setSStorageInfo("workplace",$(_pageId + " .workUnit").val());//工作单位
			    appUtils.setSStorageInfo("resign",$(_pageId + " .post").val());//职务
			    appUtils.setSStorageInfo("is_tax_resident",$(_pageId + " .taxStatus").attr("value"));//税收居民身份
			    appUtils.setSStorageInfo("credit_record",credit_record);//诚信记录
			    appUtils.setSStorageInfo("email",$(_pageId + " .mailbox").val());//邮箱
				
			    //新开，则走新开流程
							if(appUtils.getSStorageInfo("openChannel") == "new") {
								newOpen();
							}
							// 转户，则走转户流程
							else if(appUtils.getSStorageInfo("openChannel") == "change") {
								// 转户，模拟视频见证通过，否则下载证书的时候后台  会出现 cert_uid 错误
								var syncQQUserInfoParam = {
									user_id: appUtils.getSStorageInfo("user_id")
								};
								// 模拟视频通过
								service.syncQQUserInfo(syncQQUserInfoParam, function(data) {
									var error_no = data.error_no;
									var error_info = data.error_info;
									if(error_no == 0) {
										var param = {
											user_id: appUtils.getSStorageInfo("user_id")
										};	
										//如果是从视频见证页面驳回跳转回来的，还要跳转到视频页面
										if(personinfoFlag.need_personInfo==1 ||personinfo == "SYS:10012"){
												//驳回后 重新提交信息
												rejectStep();
											}
										else if(photoFlag.photoFlag=="SYS:10011"||photoFlag.need_videophoto_front==1||photoFlag.need_videophoto_back==1){
												rejectStepPhoto();
											}
										else{
											appUtils.pageInit("account/personInfo", "account/signProtocol");	
										}
									} else {
										layerUtils.iLoading(false);
										layerUtils.iAlert(error_info, -1);
									}
								});
								layerUtils.iLoading(false);
							}
			
							// 转户走了新开，提示走转户
							else if(error_no == -50152819) {
								layerUtils.iLoading(false);
								utils.layerTwoButton("系统检测到您已开立证券账户为：【" + error_info + "】，请进行转户流程!", "马上转户", "退出系统", function() {
									changeState(); // 走转户流程
								}, function() {
									require("shellPlugin").callShellMethod("closeAppPlugin", null, null); // 退出系统
								});
							}
							// 新开走了转户，提示走新开流程
							else if(error_no == -50152820) {
								appUtils.setSStorageInfo("idCardNo", $(_pageId + " .idCardNo").val());
								//appUtils.setSStorageInfo("custname", $(_pageId + " .name").val().trim());
								layerUtils.iLoading(false);
								utils.layerTwoButton("您未开通股东账户，请走新开流程!", "立即开户", "退出系统", function() {
									newOpen(); //走新开流程
								}, function() {
									require("shellPlugin").callShellMethod("closeAppPlugin", null, null); // 退出系统
								});
							}
							// 新开查到单边市场
							else if(error_no == -50152829) {
								appUtils.setSStorageInfo("idCardNo", $(_pageId + " .idCardNo").val());
								//appUtils.setSStorageInfo("custname", $(_pageId + " .name").val().trim());
								layerUtils.iLoading(false);
								utils.layerTwoButton("系统检测到您已开立证券账户为：【" + error_info + "】", "继续开户", "马上转户", function() {
									newOpen(); // 走新开流程
								}, function() {
									changeState(); // 走转户流程
								});
							} else {
								layerUtils.iLoading(false);
								layerUtils.iAlert(data.error_info); // 填写资料失败，弹出提示
							}
			  
			}else {
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info); // 填写资料失败，弹出提示
				}
		}, false);
      
	}

	/* 改变流程状态，走转户 */
	function changeState() {
		// session中的openChannel改为转户
		appUtils.setSStorageInfo("openChannel", "change");
		var newopenParam = {
			user_id: appUtils.getSStorageInfo("user_id"),
			uploadimg_flag: "0",
			opacctkind_flag: "1" // 转户
		}
		service.queryChangeState(newopenParam, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0) {
				// 跳转之前，修改 session 中 photosInfo 的 fillInformationInParam
				var photosInfo = JSON.parse(appUtils.getSStorageInfo("photosInfo"));
				// 设置 photosInfo 的 isChangeProcess 属性，true 是更改流程
				photosInfo.isChangeProcess = true;
				photosInfo.fillInformationInParam.idno = $(_pageId + " .idCardNo").val();
				photosInfo.fillInformationInParam.custname = $(_pageId + " .name").val().trim();
				photosInfo.fillInformationInParam.ethnicname = $(_pageId + " .ethnicname").val();
				photosInfo.fillInformationInParam.native = $(_pageId + " .idCardAddress").val(); // 证件地址
				photosInfo.fillInformationInParam.policeorg = $(_pageId + " .signDepartment").val(); // 签发机关
				photosInfo.fillInformationInParam.birthday = $(_pageId + " .idCardNo").attr("birthday"); // 出生日期
				photosInfo.fillInformationInParam.idbegindate = $(_pageId + " .idBeginDate").val();
				photosInfo.fillInformationInParam.idenddate = $(_pageId + " .idEndDate").val();
				photosInfo.fillInformationInParam.postid = $(_pageId + " .zipCode").val(); // 邮政编码
				// 职业
				photosInfo.fillInformationInParam.occupational = {
					"text": $(_pageId + " .selectOccupation").text(),
					"value": $(_pageId + " .selectOccupation").attr("value")
				};
				// 学历
				photosInfo.fillInformationInParam.degree = {
					"text": $(_pageId + " .selectDegree").text(),
					"value": $(_pageId + " .selectDegree").attr("value")
				};
				//行业
				photosInfo.fillInformationInParam.occupation = {
					"text": $(_pageId + " .selectIndustry").text(),
					"value": $(_pageId + " .selectIndustry").attr("value")
				};
				// 重新设置  session 中 photosInfo
				appUtils.setSStorageInfo("photosInfo", JSON.stringify(photosInfo));
				// 跳到转户的上传照片页面
				appUtils.pageInit("account/personInfo", "account/uploadPhotoChange", {});
			} else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info, -1);
			}
		}, false);
	}

	/*走新开户*/
	function newOpen(){
		// session中的openChannel改为新开
		appUtils.setSStorageInfo("openChannel", "new");
		var newopenParam = {
			user_id: appUtils.getSStorageInfo("user_id"),
			user_name:appUtils.getSStorageInfo("custname"),
			uploadimg_flag: "1", //身份证上传成功
			opacctkind_flag: "0" //新开户
		};
		service.queryChangeState(newopenParam, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0) {
				// 再次调用提交用户信息接口, 添加入参submitflag =0
				//var param = setSubmitDataParam();
				//param.submitflag = "0";
				//service.submitUserInfo(param, function(data) {
				//	var error_no = data.error_no;
				//	var error_info = data.error_info;
				//	if(error_no == 0) {
						var param = {
							user_id: appUtils.getSStorageInfo("user_id"),
							user_name:appUtils.getSStorageInfo("custname")
						};
						personinfo = appUtils.getPageParam("personinfoFlag");
						personinfoFlag = appUtils.getSStorageInfo("personinfoFlag");
						photoFlag = appUtils.getSStorageInfo("photoFlag");
      					photoFlag = JSON.parse(photoFlag);
      					personinfoFlag = JSON.parse(personinfoFlag);
						//如果是从视频见证页面驳回跳转回来的，还要跳转到视频页面
						if(personinfoFlag.need_personInfo==1 ||personinfoFlag.personinfoFlag == "SYS:10012"||personinfo =="SYS:10012"){
								//驳回后 重新提交信息
								rejectStep();
							}
						else if(photoFlag.photoFlag=="SYS:10011"||photoFlag.need_videophoto_front==1||photoFlag.need_videophoto_back==1){
								rejectStepPhoto();
							}
						else{
							appUtils.pageInit("account/personInfo", "account/signProtocol");
						
						}
				//	} else {
				//		layerUtils.iLoading(false);
				//		layerUtils.iAlert(data.error_info);
				//	}
				//});
			} else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(data.error_info, -1);
			}

		}, false);
	}


//驳回后重新提交信息
    function rejectStepPhoto(){
          //调用提交补全资料接口
			var notifyParam = {
				"userid" : appUtils.getSStorageInfo("user_id"),
				 "fieldname" : "video_photo"  // 通知视频驳回的身份证照片已补全
			};
			service.rejectStep(notifyParam,function(data){
				if(data.error_no == 0)
				{
					appUtils.setSStorageInfo("isBack", "backInfo");  //标志重新提交资料成功
					appUtils.pageInit("account/personInfo", "account/videoNotice");  
	            }
	            else{
	                layerUtils.iAlert(data.error_info);
		            layerUtils.iLoading(false);
	            }
          })
     
    }

  //驳回后重新提交信息
    function rejectStep(){
          //调用提交补全资料接口
			var notifyParam = {
				"userid" : appUtils.getSStorageInfo("user_id"),
				 "fieldname" : "idno"  // 通知个人信息已补全
			};
			service.rejectStep(notifyParam,function(data){
				if(data.error_no == 0)
				{
					var fillInformationInParam = {"custname" :appUtils.getPageParam("custname"), // 客户姓名
						"ethnicname" :appUtils.getPageParam("ethnicname"), //民族
						"idno" : appUtils.getPageParam("idno"), // 身份证号
						"policeorg" :appUtils.getPageParam("policeorg"), // 签发机关
						"native" :appUtils.getPageParam("native"),// 证件地址
						"native" :appUtils.getPageParam("native"),// 联系地址和证件地址设置相同的
						"idbegindate" :appUtils.getPageParam("idbegindate"), //起始期限
						"idenddate" :appUtils.getPageParam("idenddate"),//结束期限
						"postid" :appUtils.getPageParam("postid") //邮编
					 }
					appUtils.setSStorageInfo("isBack", "backInfo");  //标志重新提交资料成功
					appUtils.pageInit("account/personInfo", "account/videoNotice",fillInformationInParam);
			       
	            }
	            else{
	                layerUtils.iAlert(data.error_info);
		            layerUtils.iLoading(false);
	            }
          })
     
    }


	/* 根据身份证号进行判断性别: 倒数第二位数字，偶数为女，基数为男 */
	function checkSexId(idno) {
		var value = idno.charAt(idno.length - 2); // 身份证倒数第二位数字
		var isnum = value % 2;
		var sexid = "";
		if(isnum == womenId) {
			sexid = womenId;
		} else {
			sexid = manId;
		}
		return sexid;
	}

	/* 获取用户信息*/
	function setSubmitDataParam() {
		var idno = $(_pageId + " .idCardNo").val(); // 身份证号
		// 判断性别，根据身份证传入男或女，也可以通过身份证号进行判断
		var sexId = "";
		if(appUtils.getPageParam("gender") == "男") {
			sexId = manId;
		} else if(appUtils.getPageParam("gender") == "女") {
			sexId = womenId;
		} else {
			sexId = checkSexId(idno); // 根据身份证判断
		}
		var idenddate = "";
		if($(_pageId + " .idEndDate").val() == "长期"){
			idenddate = "3000-12-31";
		}else{
			idenddate = $(_pageId + " .idEndDate").val();
		}
		var param = {
			"user_id": appUtils.getSStorageInfo("user_id"),
			"infocolect_channel": "3", // 信息来源渠道 0：PC  3：手机
			"idtype": "00", // 证件类别，数据字典中定义的是 00
			"idno": idno, // 身份证号
			"ethnicname": $(_pageId + " .ethnicname").val(), // 民族
			"custname": $(_pageId + " .name").val().trim(),
			"birthday": $(_pageId + " .idCardNo").attr("birthday"), // 身份证修改了，出生日期也要修改
			"idbegindate": $(_pageId + " .idBeginDate").val(), // 证件开始日期
			"idenddate": idenddate, // 证件结束日期
			"native": $(_pageId + " .idCardAddress").val().replace(/\s+/g, ""), // 证件地址
			"policeorg": $(_pageId + " .signDepartment").val(), // 签发机关
			"usersex": sexId, // 用户性别，男 0 女 1
			"nationality": "156", // 屏蔽，待解决  // 国籍地区，必须写 156
			"addr": $(_pageId + " .address_text").val().replace(/\s+/g, ""), // 联系地址
			"postid": $(_pageId + " .zipCode").val(), // 邮政编码
			"edu": $(_pageId + " .selectDegree").attr("value"), // 学历代码
			"recommendno": appUtils.getSStorageInfo("recommendno"), //推荐人号码
			"profession_code": $(_pageId + " .selectOccupation").attr("value"), // 职业代码
			'occupation': $(_pageId + " .selectIndustry").attr("value"),//appUtils.getSStorageInfo('industryCode') 行业代码
			"branchno": appUtils.getSStorageInfo("branchno"), // 营业部代码
			"commission": appUtils.getSStorageInfo("commission"), // 营业部代码佣金代码
			"provinceno": "", // 省份代码, 屏蔽, 待解决 
			"cityno": "", // 城市代码
			"ipaddr": appUtils.getSStorageInfo("ip"), // ip 地址，在获取 短信验证码 的时候，就已经把 ip 和 mac 保存到 session 里面了
			"macaddr": appUtils.getSStorageInfo("mac"), // mac 地址
			"idcardmodify": idCardModify ? 1 : 0, // 身份证是否被手动修改，被修改传 1 ，否则传 0
			"control_person": control_person,//控制人
			"benefit_person": benefit_person,//受益人
			"workplace": $(_pageId + " .workUnit").val(),//工作单位
			"resign": $(_pageId + " .post").attr("value"),//职务
			"email": $(_pageId + " .mailbox").val(),//邮箱
			"credit_record": credit_record,//诚信记录
			"is_tax_resident": $(_pageId + " .taxStatus").attr("value"),//税收居民身份
			"province": provincename,//联系地址省份
			"city": cityname,//联系地址市
			"area": areaname//联系地址区
		};
		return param;
	}

	/* 获取职业、学历、性别列表*/
	function queryDataDict() {
		// 获取职业
		var profession_code = appUtils.getSStorageInfo("profession_code"); // 获取session中的职业 
		var occupationalParam = {
			"enum_type": "occupational"
		};
		service.queryDataDict(occupationalParam, function(data) {
			var error_no = data.error_no,
				error_info = data.error_info;
			$(_pageId + " .sel_list:eq(0) ul li").remove(); // 首先清空数据
			if(error_no == "0" && data.results.length != 0) {
				var profession = data.results;
				for(var i = 0; i < profession.length; i++) {
					var str = "<li><span class='profession0" + i + "' value='" + profession[i].item_value + "'>" + profession[i].item_name + "</span></li>"
					$(_pageId + " .sel_list:eq(0) ul").append(str);
					if(profession_code != "" && profession[i].item_value == profession_code) {
						$(_pageId + " .selectOccupation").text(profession[i].item_name);
						$(_pageId + " .selectOccupation").val(profession[i].item_value);
					}
					BindSelectOccupation(i); // 预绑定选择职业的事件
				}
				queryAdapter(); // 再获取学历
			} else {
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1, error_info); // 提示错误信息
			}
		}, false, true, handleTimeout);
	}

	/* 获取学历 */
	function queryAdapter() {
		var edu = appUtils.getSStorageInfo("edu"); // 获取session中的学历 
		var adapterParam = {
			"enum_type": "adapter"
		};
		service.queryDataDict(adapterParam, function(data) {
			var error_no = data.error_no,
				error_info = data.error_info;
			$(_pageId + " .sel_list:eq(1) ul li").remove(); // 首先清空数据
			if(error_no == "0" && data.results.length != 0) {
				var adapter = data.results;
				for(var i = 0; i < adapter.length; i++) {
					var str = "<li><span class='degree0" + i + "' value='" + adapter[i].item_value + "'>" + adapter[i].item_name + "</span></li>"
					$(_pageId + " .sel_list:eq(1) ul").append(str);
					if(edu != "" && adapter[i].item_value == edu) {
						$(_pageId + " .selectDegree").text(adapter[i].item_name);
						$(_pageId + " .selectDegree").val(adapter[i].item_value);
					}
					BindSelectDegree(i); // 预绑定选择学历的事件	
				}
				queryHangye(); // 获取行业
			} else {
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1, error_info); // 提示错误信息
			}
		}, false, true, handleTimeout);
	}
   // 获取行业
	function queryHangye() {
		var occupation = appUtils.getSStorageInfo("occupation"); // 
		var hangyeParam = {
			"enum_type": "occupation"
		};
		service.queryDataDict(hangyeParam, function(data) {
			var error_no = data.error_no,
				error_info = data.error_info;
			$(_pageId + " .sel_list:eq(2) ul li").remove(); // 首先清空数据
			if(error_no == "0" && data.results.length != 0) {
				var hangye = data.results;
				for(var i = 0; i < hangye.length; i++) {
					var str = "<li ><span class='industry0" + i + "' value='" + hangye[i].item_value + "'>" + hangye[i].item_name + "</span></li>"
					$(_pageId + " .sel_list:eq(2) ul").append(str);
					if(hangye && hangye[i].item_value == occupation) {
						$(_pageId + " .selectIndustry").text(hangye[i].item_name);
						$(_pageId + " .selectIndustry").val(hangye[i].item_value);
					}
					BindSelectIndustry(i); // 预绑定选择学历的事件	
				}
				querySex(); // 获取性别
			} else {
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1, error_info); // 提示错误信息
			}
		}, false, true, handleTimeout);
	}
   
	/* 获取性别 */
	function querySex() {
		var sexParam = {
			"enum_type": "sex"
		};
		service.queryDataDict(sexParam, function(data) {
			var error_no = data.error_no,
				error_info = data.error_info;
			if(error_no == "0" && data.results.length != 0) {
				var sex = data.results;
				var sexvalue = "";
				for(var i = 0; i < sex.length; i++) {
					sexvalue = sex[i].item_name;
					if(sexvalue == "男") {
						manId = sex[i].item_value;
					}
					if(sexvalue == "女") {
						womenId = sex[i].item_value;
					}
				}
				queryTaxStatus();
			} else {
				layerUtils.iMsg(-1, error_info); // 提示错误信息
			}
		}, true, true, handleTimeout);
	}

	/*获取税收身份*/
	function queryTaxStatus(){
		var is_tax_resident = appUtils.getSStorageInfo("is_tax_resident");
		var taxStatusParam = {
				"enum_type": "is_tax_resident"
		};
		service.queryDataDict(taxStatusParam, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			$(_pageId + " .sel_list:eq(3) ul li").remove(); // 首先清空数据
			if(error_no == "0" && data.results.length != 0) {
				var taxStatus = data.results;
				for(var i = 0; i < taxStatus.length; i++) {
					var str = "<li ><span class='taxStatus0" + i + "' value='" + taxStatus[i].item_value + "'>" + taxStatus[i].item_name + "</span></li>"
					$(_pageId + " .sel_list:eq(3) ul").append(str);
					if(taxStatus && taxStatus[i].item_value == is_tax_resident) {
						$(_pageId + " .taxStatus").text(taxStatus[i].item_name);
						$(_pageId + " .taxStatus").val(taxStatus[i].item_value);
					}
					BindSelectTaxStatus(i);
				}
				queryRecord();
			}else {
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1, error_info); // 提示错误信息
			}
		}, true, true, handleTimeout);
	}
	
	/*获取不良诚信记录列表*/
	function queryRecord(){
		credit_record = appUtils.getSStorageInfo("credit_record");//诚信记录
		var credit_recordArray="";
		$(_pageId + " .credit_record").text("");
		if(credit_record != null&&credit_record!=undefined){
			credit_recordArray = credit_record.split(",");
		}else{
			credit_record="";
		}
		check_val="";
		var recordParam = {
				"enum_type": "credit_record"
		}
		service.queryDataDict(recordParam, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			$(_pageId + " .bg_gray .record_list:eq(1) p").remove(); // 首先清空数据
			if(error_no == "0" && data.results.length != 0) {
				var record = data.results;
				for(var i = 0; i < record.length; i++) {
					var str = "<p class='record0" + i + "' value='" + record[i].item_value + "'>" + record[i].item_name + "</p>"
					if(record[i].item_value == "99"){
						$(_pageId + " .bg_gray .record_list:eq(0)").html(str);
					}else{
						$(_pageId + " .bg_gray .record_list:eq(1)").append(str);
					}
					if(credit_record == "" || credit_record == "99" || credit_record == undefined){
						$(_pageId + " .bg_gray .record_list:eq(0) p").addClass("on");
						check_val_str = $(_pageId + " .bg_gray .record_list:eq(0) p").text();
						$(_pageId + " .credit_record").text(check_val_str);
						credit_record = $(_pageId + " .bg_gray .record_list:eq(0) p").attr("value");
					}else
					if(credit_record!=""&&credit_record.indexOf(record[i].item_value)!=-1){
						check_val += record[i].item_name+",";
						$(_pageId + " .bg_gray p[value='"+record[i].item_value+"']").addClass("on");
					}
					
				}
				BindSelectRecord();
				if(check_val!=""){
					check_val_str = check_val.substring(0,check_val.length - 1);
					$(_pageId + " .credit_record").text(check_val_str);
				}else{
					$(_pageId + " .bg_gray .record_list:eq(0) p").click();
				}
				queryResign();
			}else {
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1, error_info); // 提示错误信息
			}
		}, true, true, handleTimeout);
	}
	
	/*获取职务*/
	function queryResign(){
		var resign = appUtils.getSStorageInfo("resign");
		var resignParam = {
				"enum_type": "resign"
		};
		service.queryDataDict(resignParam, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			$(_pageId + " .sel_list:eq(4) ul li").remove(); // 首先清空数据
			if(error_no == "0" && data.results.length != 0) {
				var post = data.results;
				for(var i = 0; i < post.length; i++) {
					var str = "<li ><span class='post0" + i + "' value='" + post[i].item_value + "'>" + post[i].item_name + "</span></li>"
					$(_pageId + " .sel_list:eq(4) ul").append(str);
					if(post && post[i].item_value == resign) {
						$(_pageId + " .post").text(post[i].item_name);
						$(_pageId + " .post").val(post[i].item_value);
					}
					BindSelectrResign(i);
				}
			}else {
				layerUtils.iLoading(false);
				layerUtils.iMsg(-1, error_info); // 提示错误信息
			}
		}, true, true, handleTimeout);
	}
	
	/* 处理请求超时 */
	function handleTimeout() {
		layerUtils.iConfirm("请求超时，是否重新加载？", function() {
			queryDataDict(); // 再次获取职业和学历
		});
	}

	/*预绑定选择职务的事件*/
	function BindSelectrResign(i){
		appUtils.bindEvent($(_pageId + " .sel_list:eq(4) ul .post0" + i), function(e) {
			$(_pageId + " .post").attr("value", $(this).attr("value"));
			$(this).parent().addClass("active").siblings().removeClass("active");
			var check_val = $(this).text();
			$(_pageId + " .post").text(check_val);
			$(_pageId + " .sel_list:eq(4)").slideUp("fast", function() {
//				$("body #bodyContent").css("overflow", "visible");
			});
			$page.find('.post').text(check_val);
			$page.find('.post').attr("value",$(this).attr("value"));
			// 存储职务代码
			appUtils.setSStorageInfo('resign',$(this).attr("value"));
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/* 预绑定选择职业的事件 */
	function BindSelectOccupation(i) {
		appUtils.bindEvent($(_pageId + " .sel_list:eq(0) ul .profession0" + i), function(e) {
			$(_pageId + " .selectOccupation").attr("value", $(this).attr("value"));
			$(this).parent().addClass("active").siblings().removeClass("active");
			var check_val = $(this).text();
			$(_pageId + " .selectOccupation").text(check_val);
			$(_pageId + " .sel_list:eq(0)").slideUp("fast", function() {
//				$("body #bodyContent").css("overflow", "visible");
			});
			$page.find('.selectOccupation').text(check_val);
			$page.find('.selectOccupation').attr("value",$(this).attr("value"));
			// 存储职业代码
			appUtils.setSStorageInfo('profession_code',$(this).attr("value"));
			e.stopPropagation(); // 阻止冒泡
		});
	}

	/*  预绑定选择学历的事件 */
	function BindSelectDegree(i) {
		appUtils.bindEvent($(_pageId + " .sel_list:eq(1) ul .degree0" + i), function(e) {
			// strong 不能用 val() 方法设置 value ，用的话无效
			$(_pageId + " .selectDegree").attr("value", $(this).attr("value"));
			$(this).parent().addClass("active").siblings().removeClass("active");
			var check_val = $(this).text();
			$(_pageId + " .selectDegree").text(check_val);
			$(_pageId + " .sel_list:eq(1)").slideUp("fast", function() {
//				$("body #bodyContent").css("overflow", "visible");
			});
			$page.find('.selectDegree').text(check_val);
			$page.find('.selectDegree').attr("value",$(this).attr("value"));
			// 存储学历代码
			appUtils.setSStorageInfo('edu',$(this).attr("value"));
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
   /*  预绑定选择行业的事件 */
	function BindSelectIndustry(i) {
		appUtils.bindEvent($(_pageId + " .sel_list:eq(2) ul .industry0" + i), function(e) {
			// strong 不能用 val() 方法设置 value ，用的话无效
			$(_pageId + " .selectIndustry").attr("value", $(this).attr("value"));
			$(this).parent().addClass("active").siblings().removeClass("active");
			var check_val = $(this).text();
			$(_pageId + " .selectIndustry").text(check_val);
			$(_pageId + " .sel_list:eq(2)").slideUp("fast", function() {
//				$("body #bodyContent").css("overflow", "visible");
			});
			$page.find('.selectIndustry').text(check_val);
			$page.find('.selectIndustry').attr("value",$(this).attr("value"));
			// 存储行业代码
			appUtils.setSStorageInfo('occupation',$(this).attr("value"));
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/*  预绑定选择税收身份的事件 */
	function BindSelectTaxStatus(i) {
		appUtils.bindEvent($(_pageId + " .sel_list:eq(3) ul .taxStatus0" + i), function(e) {
			// strong 不能用 val() 方法设置 value ，用的话无效
			$(_pageId + " .taxStatus").attr("value", $(this).attr("value"));
			$(this).parent().addClass("active").siblings().removeClass("active");
			var check_val = $(this).text();
			$(_pageId + " .taxStatus").text(check_val);
			$(_pageId + " .sel_list:eq(3)").slideUp("fast", function() {
//				$("body #bodyContent").css("overflow", "visible");
			});
			$page.find('.taxStatus').text(check_val);
			$page.find('.taxStatus').attr("value",$(this).attr("value"));
			// 存储税收身份代码
			appUtils.setSStorageInfo('is_tax_resident',$(this).attr("value"));
			if($(this).attr("value") == "1"){
				/*service.getProtocolInfo({"econtract_no":"700"},function(data){
					if(data.error_no == 0){
        				protocolArrays = new Array(); // 存放协议签名值
        				// 添加值到数组中
                        var protocol = {
                            "protocol_id":data.results[0].econtract_no,
                            "protocol_dcsign": "",
                            "summary": data.results[0].econtract_md5
                        };
                        protocolArrays.push(protocol);
        				var html="<p>"+data.results[0].econtract_content+"</p>";//href='javascript:;' id='protocol0' protocol-id=\""+data.results[0].econtract_no+"\" econtract_version=\""+data.results[0].econtract_version+"\" style='font-size:20px;'
        				
        				$(_pageId+" #commitment").show().find(".rule_cont").html(html);
        				//$(_pageId+" #commitment").show();
        			}else{
        				layerUtils.iLoading(false);
    					layerUtils.iAlert(data.error_info); // 查询失败，弹出提示
        			}
				});*/
				
			}else{
				layerUtils.iAlert("鉴于您税收身份的特殊性，请您临柜办理开户业务。", -1);
				return false;
			}
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/*预绑定不良诚信记录的事件*/
	function BindSelectRecord(i){
		appUtils.bindEvent($(_pageId + " .bg_gray .record_list:eq(0) p"),function(){
			$(this).toggleClass("on");
			if($(this).hasClass("on")){
				$(_pageId + " .bg_gray .record_list:eq(1) p").removeClass("on");
			}
		});
		appUtils.bindEvent($(_pageId + " .bg_gray .record_list:eq(1) p"),function(){
			$(this).toggleClass("on");
				if($(this).hasClass("on")){
					$(_pageId + " .bg_gray .record_list:eq(0) p").removeClass("on");
					
				}
    	});
	}
	
	/* 信息提交校验 */
	function verifyInfo() {
		var name = $(_pageId + " .user_form .name").val(); //姓名
		var idCardNo = $(_pageId + " .user_form .idCardNo").val(); //身份证
		var signDepartment = $(_pageId + " .user_form .signDepartment").val(); //签发机关
		var idCardAddress = $(_pageId + " .user_form .idCardAddress").val(); //证件地址
		var address = $(_pageId + " .user_form .address").text(); //联系地址
		var address_text = $(_pageId + " .address_text").val(); //详细地址
		var idBeginDate = $(_pageId + " .user_form .idBeginDate").val(); //起始期限
		var idEndDate = "";
		if($(_pageId + " .user_form .idEndDate").val() == "长期"){
			idEndDate = "3000-12-31";
		}else{
			idEndDate = $(_pageId + " .user_form .idEndDate").val(); //结束期限
		}
		var zipCode = $(_pageId + " .user_form .zipCode").val(); //邮编
		var selectOccupation = $(_pageId + " .input_form .selectOccupation").text(); //职业
		var selectDegree = $(_pageId + " .input_form .selectDegree").text(); //学历
		var selectIndustry = $(_pageId + " .input_form .selectIndustry").text(); //行业
		var CurrentDate = new Date().format("yyyy/MM/dd");
		var workUnit = $(_pageId + " .workUnit").val(); //工作单位
		var post = $(_pageId + " .user_form .post").text(); //职务
		var mailbox = $(_pageId + " .user_form .mailbox").val(); //邮箱
		var taxStatus = $(_pageId + " .input_form .taxStatus").text(); //税收身份
		control_person = $(_pageId + " .user_form .name").val();
		benefit_person = $(_pageId + " .user_form .name").val();
//		 appUtils.setSStorageInfo('occupation',$(_pageId + " .industryList ul li span").attr('value')); //行业
		if(name == "") {
			layerUtils.iMsg(-1, "姓名不能为空");
			return false;
		} 
		if(idCardNo == "") {
			layerUtils.iMsg(-1, "身份证不能为空");
			return false;
		}
		// 验证身份证的格式
		if(!validatorUtil.isCardID(idCardNo)) {
			layerUtils.iMsg(-1, "请输入正确的身份证号码!");
			return false;
		}
		/*if(signDepartment == "") {
			layerUtils.iMsg(-1, "签发机关不能为空");
			return false;
		}*/
		if(idCardAddress == "") {
			layerUtils.iMsg(-1, "证件地址不能为空");
			return false;
		}
		if(idCardAddress.length <= 8) {
			layerUtils.iMsg(-1, "证件地址不符合要求");
			return false;
		}
		if(address == "请选择省市区"){
			layerUtils.iMsg(-1, "联系地址不能为空");
			return false;
		}
		
		if(address_text == "") {
			layerUtils.iMsg(-1, "详细地址不能为空");
			return false;
		}
		if(address_text.length < 6) {
			layerUtils.iMsg(-1, "详细地址不能少于6个字");
			return false;
		}
		if(idBeginDate == "") {
			layerUtils.iMsg(-1, "身份证起始期限不能为空");
			return false;
		}
		if(idEndDate == "") {
			layerUtils.iMsg(-1, "身份证结束期限不能为空");
			return false;
		}
		
		if(zipCode == "") {
			layerUtils.iMsg(-1, "邮编不能为空");
			return false;
		}
		if(!require("validatorUtil").isPostalCode(zipCode)) {
			layerUtils.iMsg(-1, "邮编格式不正确,请重新输入");
			return false;
		}
		var szReg=/^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
		if(mailbox != "" && !szReg.test(mailbox)){
			layerUtils.iMsg(-1, "邮箱格式不正确,请重新输入");
			return false;
		}
		if(selectDegree == "请选择学历") {
			layerUtils.iMsg(-1, "学历不能为空");
			return false;
		}
		if(selectIndustry == "请选择行业") {
			layerUtils.iMsg(-1, "行业不能为空");
			return false;
		}
		if(selectOccupation == "请选择职业") {
			layerUtils.iMsg(-1, "职业不能为空");
			return false;
		}
		if(workUnit != "" && workUnit.length < 2) {
			layerUtils.iMsg(-1, "工作单位不能少于2个字");
			return false;
		}
		if(post == "请选择职务"){
			layerUtils.iMsg(-1, "职务不能为空");
			return false;
		}
		if(taxStatus == "请选择税收居民身份"){
			layerUtils.iMsg(-1, "税收居民身份不能为空");
			return false;
		}
		if(taxStatus == "仅为非居民" || taxStatus == "既是中国税收居民又是其他国家（地区）税收居民"){
			layerUtils.iMsg(-1, "鉴于您税收身份的特殊性，请您临柜办理开户业务。");
			return false;
		}
		if($(_pageId + " .credit_record").text() == "请选择诚信记录！"){
			layerUtils.iMsg(-1, "请选择诚信记录！");
			return false;
		}
		if($(_pageId+" #actual_controller .text").find("input").prop("checked") == false){
			layerUtils.iMsg(-1, "账户实际控制人非您本人，网上无法核实准确信息，请您临柜办理开户业务!");
			return false;
		}
		if($(_pageId+" #actual_beneficiary .text").find("input").prop("checked") == false){
			layerUtils.iMsg(-1, "账户受益人非您本人，网上无法核实准确信息，请您临柜办理开户业务!");
			return false;
		}
		// 发送身份证存在性检查之前，前端验证身份证的格式
		if(!validatorUtil.isCardID(idCardNo)) {
			layerUtils.iMsg(-1, "请输入正确的身份证号码!");
			return false;
		}
		// 对不满 18 周岁进行控制
		if(idCardNo.length == 18) {
			var dateStr = idCardNo.substring(6, 10) + "/" + idCardNo.substring(10, 12) + "/" + idCardNo.substring(12, 14),
				userAge = new Date().getTime() - Date.parse(dateStr);
			userAge = userAge / (365 * 24 * 60 * 60 * 1000);
			if(parseInt(userAge) < 18) {
				layerUtils.iAlert("您的年龄未满 18 周岁，不允许开户!", -1);
				return false;
			}
		}
		// 验证有效期的格式
		var dateReg = /^[1-3]\d{3}-(0|1)\d-[0-3]\d$/;
		if(!(dateReg.test(idBeginDate) && validatorUtil.isDate(idBeginDate))) {
			layerUtils.iMsg(-1, "您的身份证日期无效，请您更换有效身份证!");
			return false;
		}
		if(!(dateReg.test(idEndDate) && validatorUtil.isDate(idEndDate))) {
			layerUtils.iMsg(-1, "您的身份证日期无效，请您更换有效身份证!!");
			return false;
		}

		// 校验身份证期限是否符合格式
		idBeginDate = idBeginDate.replaceAll("-", "/");
		idEndDate = idEndDate.replaceAll("-", "/");
		if(Date.parse(idBeginDate) >= Date.parse(idEndDate)) {
			layerUtils.iMsg(-1, "有效期的起始时间必须小于结束时间!");
			return false;
		}
		// 校验身份证期限是否到期
		if(Date.parse(CurrentDate) >= Date.parse(idEndDate)) {
			layerUtils.iMsg(-1, "您的身份证已过期，请您更换有效身份证!");
			return false;
		}
		// 校验身份证日期是否有效
		if(Date.parse(CurrentDate) <= Date.parse(idBeginDate)) {
			layerUtils.iMsg(-1, "您的身份证日期无效，请您更换有效身份证!");
			return false;
		}

		// 页面入参的 身份证号 ，身份证号最多只允许修改五位
		if(appUtils.getPageParam("idno")) {
			var pageInIdCardNo = appUtils.getPageParam("idno");
		} else {
			var pageInIdCardNo = appUtils.getSStorageInfo("idCardNo");
		}
		var countDiffe = 0; // 计算身份证修改的位数
		for(var i = 0; i < idCardNo.length; i++) {
			var oneIdNo = idCardNo.charAt(i),
				oneInIdNo = pageInIdCardNo.charAt(i);
			if(oneIdNo != oneInIdNo) {
				countDiffe++;
			}
		}
		// 如果被修改的位数不等于 0 ，countDiffe 为 true
		if(countDiffe != 0) {
			idCardModify = true;
		}
		// 未被修改，idCardModify 为 false
		else {
			idCardModify = false;
		}
		if(countDiffe > 5) {
			utils.layerTwoButton("您好,发现您的证件号码与上传的差异过大，请您确认是否需要更换身份证?", "重新上传证件", "重新修改证件号", function() {
				if(appUtils.getSStorageInfo("openChannel") == "new") {
					appUtils.pageInit("account/personInfo", "account/uploadPhoto", {});
				} else if(appUtils.getSStorageInfo("openChannel") == "change") {
					appUtils.pageInit("account/personInfo", "account/uploadPhotoChange", {});
				}
			}, function() {
				setTimeout(function() {
					$(_pageId + " .idCardNo").focus();
				}, 1000);
			});
			return false;
		}
		// 设置出生日期
		$(_pageId + " .idCardNo").attr("birthday", idCardNo.substring(6, 10) + "-" + idCardNo.substring(10, 12) + "-" + idCardNo.substring(12, 14));
		return true;
	}

	/* 日历的回调函数 */
	function calendarCallback(data) {
		// 回调数据中的 data 是字符串，需解析
		if(typeof(data) == "string") {
			data = JSON.parse(data);
		}
		if(data.selector == "idEndDate" && data.date != "长期"){
			$(_pageId+" .icon_check").removeClass("checked");
		}
		$(_pageId + " #" + data.selector).val(data.date);
	}

	/* 清理界面元素*/
	function cleanPageElement() {
		$(_pageId + " .selectOccupation").html("请选择职业"); //清理职业
		$(_pageId + " .selectDegree").html("请选择学历"); //清理学历
	}

	// 不要问我为什么不直接在已有代码上改。
	// 你觉得上面那些代码有丝毫的可维护性吗？
	/**
	 * @description 根据类型查询数据字典信息
	 * @param type {String} 数据字典类型
	 * @param callback {Function} 回调函数
	 **/
	function queryDataDictByType(type, callback) {
		var param = {
			'enum_type': type
		};

		var serviceCallback = function(data) {
			if(data.error_no === "0") {
				callback(data);
			} else {
				layerUtils.iAlert(data.error_info);
			}
		};

		service.queryDataDict(param, serviceCallback);
	}

	/**
	 * @description 填充列表信息
	 **/
	function insertListData($list, data) {
		var results = data.results,
			liString = '';
		$.each(results, function(index, item) {
			liString += '<li data-value=' + item.item_value +
				'><span>' + item.item_name +
				'</span></li>'
		});
		$list.find('ul').html(liString);
	}

	//获取省市区
	function province(){
		service.getProvinceCityArea({},function(data){
			var error_no = data.error_no,
				error_info = data.error_info;
			if(error_no=="0" && data.dsName)
			{
				provinceList = data.provinceList; //省份集合
				cityList = data.cityList;	//城市集合
				areaList = data.areaList;	//城市集合
				var plen = provinceList.length,
					clen = cityList.length,
					alen = areaList.length,
				    pro_str = "";
				if(plen==1){
					for(var i=0; i<plen; i++)
					{
						var provinceno = provinceList[i].provinceno; //省份id
						var provincename = provinceList[i].provincename;  //省份名称
						var cityno = cityList[i].cityno;
						var cname = cityList[i].cityname;
						var areano = areaList[i].areaxno;
						var aname = areaList[i].areaname;
						$(_pageId+" #ad_province").text(provincename);
						$(_pageId+" #ad_city").text(cname);
						$(_pageId+" #ad_area").text(aname);
					}
				}else{
					for(var i=0; i<plen; i++)
					{
						var provinceno = provinceList[i].provinceno; //省份id
						var provincename = provinceList[i].provincename;  //省份名称
	
						pro_str+= "<li pid='"+provinceno+"'><span>"+provincename+"</span></li>";
					}
					$(_pageId+" #ad_province").html(pro_str);  //填充省份下拉框
					bindProvince();  //点击省份
				}
			}
			else
			{
				layerUtils.iMsg(-1,error_info);  //提示错误信息
			}
		},true,true,handleTimeout);
	}
	
	/* 选中省份事件处理 */
	function bindProvince()
    {
        appUtils.bindEvent($(_pageId+" #ad_province li"),function(e){
            $(_pageId+" #ad_province").hide();
            //清空一下城市和区域的名称，以免出现未清空的问题
            if($(this).text().indexOf("市")==-1){
                $(_pageId+" #ad_city").show();
                var pid = $(this).attr("pid");
                $(this).addClass("active").siblings().removeClass("active");
                provinceTemp = $(this).text();  //当前选中省份的值
                var sel_pname = $(_pageId+" .sel_province").text();  //上一次选中省份的值
                var provincenno = "";  //省份ID
                var cityno = "";
                var cname = "";
                var city_str = "";
                //选中省份立即填充相应城市
                for(var i=0; i<cityList.length; i++)
                {
                    provincenno = cityList[i].provincenno;
                    cityno = cityList[i].cityno;
                    cname = cityList[i].cityname;
                    if(pid == provincenno)  //填充当前省份下的城市列表
                    {
                        city_str+= "<li cid='"+cityno+"'><span>"+cname+"</span></li>";
                    }
                }
                if(provinceTemp == "台湾省" || provinceTemp == "香港特别行政区" || provinceTemp == "澳门特别行政区"){
                    $(_pageId+" .address").text(provinceTemp);	  //选中值赋给选择框
                    provincename = provinceTemp;
                    areaname = "";
                    cityname = "";
                }else{
                    $(_pageId+" #ad_city").html(city_str);  //填充城市下拉框
                    e.stopPropagation();	// 阻止冒泡
                    bindCity(provinceTemp);  //点击城市
                }
            }else{
                $(_pageId+" #ad_province").hide();
                $(_pageId+" #ad_city").hide();
                $(_pageId+" #ad_area").show();
                var pid = $(this).attr("pid");
                $(this).addClass("active").siblings().removeClass("active");
                provinceTemp = $(this).text();  //当前选择城市的值
                var sel_cname = $(_pageId+" .sel_city").text();  //上次选择城市的值
                var cityno = "";  //省份ID
                var areano = "";
                var aname = "";
                var area_str = "";
                //选中市立即填充相应区
                for(var i=0; i<cityList.length; i++)
                {
                    provincenno = cityList[i].provincenno;
                    cityno = cityList[i].cityno;
                    if(pid == provincenno)  //填充当前省份下的城市列表
                    {
                        city_str = "<li cid='"+cityno+"'><span></span></li>";
                        break;
                    }
                }
                $(_pageId+" #ad_city").html(city_str);  //填充城市下拉框
                for(var i=0; i<areaList.length; i++){
                    cityno = areaList[i].cityno;
                    areano = areaList[i].areano;
                    aname = areaList[i].areaname;
                    if($(_pageId+" #ad_city li").attr("cid") == cityno)  //填充当前省份下的城市列表
                    {
                        area_str+= "<li cid='"+areano+"'><span>"+aname+"</span></li>";
                    }
                }
                $(_pageId+" #ad_area").html(area_str);  //填充城市下拉框
                e.stopPropagation();	// 阻止冒泡
                bindArea("",provinceTemp);
            }
        });
    }

	/* 选中城市事件绑定 */
	function bindCity(province)
	{
		appUtils.bindEvent($(_pageId+" #ad_city li"),function(e){
			$(_pageId+" #ad_province").hide();
			$(_pageId+" #ad_city").hide();
			$(_pageId+" #ad_area").show();
			var cid = $(this).attr("cid");
			$(this).addClass("active").siblings().removeClass("active");
			cityTemp = $(this).text();  //当前选择城市的值
			var sel_cname = $(_pageId+" .sel_city").text();  //上次选择城市的值
			
			var cityno = "";  //省份ID
			var areano = "";
			var aname = "";
			var area_str = "";
			//选中市立即填充相应区
			for(var i=0; i<areaList.length; i++)
			{
				cityno = areaList[i].cityno;
				areano = areaList[i].areano;
				aname = areaList[i].areaname;
				if(cid == cityno)  //填充当前省份下的城市列表
				{
					area_str+= "<li cid='"+areano+"'><span>"+aname+"</span></li>";
				}
			}
			$(_pageId+" #ad_area").html(area_str);  //填充城市下拉框
			e.stopPropagation();	// 阻止冒泡
			bindArea(province,cityTemp);
		});
	}
	
	/* 选中区事件绑定 */
	function bindArea(province,city)
	{
		appUtils.bindEvent($(_pageId+" #ad_area li"),function(e){
			var aid = $(this).attr("aid");
			$(this).addClass("active").siblings().removeClass("active");
			areaname = $(this).text();  //当前选择城市的值
            provincename = province;
            cityname = city;
			var sel_cname = $(_pageId+" .sel_area").text();  //上次选择城市的值
			var area_count = province + city +areaname;
			$(_pageId+" .address").text(area_count);	  //选中值赋给选择框
			$(_pageId+" .address1").hide();
			e.stopPropagation();	// 阻止冒泡
		});
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getBranch();  // 再次获取营业部
		});
	}
	
	var personInfo = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"pageBack": pageBack,
		"destroy": destroy
	};

	module.exports = personInfo;
});