/**
* 风险测评结果
*/
define("project/scripts/account/riskAssessmentResult",function(require,exports,module){
	var appUtils = require("appUtils"),
	    service= require("serviceImp").getInstance(),
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
        utils = require("utils"),
        Map = require("map"),
        fristMap = null,  //  存放所有相关协议
        protocolArray = [],  // 存放协议签名值
        showStr = "",
        isshow = false,
        allIsShow = false,
        num = 0,
        numStr = [],
        countProtocol = 0,
        riskexp = "",
        lowestLevel = "",
		_pageId = "#account_riskAssessmentResult";
	
	function init()
	{ 
		riskexp = appUtils.getPageParam("riskexp"); //风险等级级别
		lowestLevel = appUtils.getPageParam("lowestLevel");//保守型最低类别标识
		if((riskexp == "11" && lowestLevel == "0") || riskexp == "12"){
			isshow = true;
		}else{
			isshow = false;
		}
		$(_pageId+" .mt15 span").removeClass("checked");
		//设置按钮显示提示文字
		if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			if(appUtils.getSStorageInfo("finance") == "finance")
			{
				$(_pageId+" .fix_bot .ct_btn a").html("继续开户 >");  // 理财户
			}
			else
			{
				$(_pageId+" .fix_bot .ct_btn a").html("继续转户 >");  // 转户
			}
		}
		else
		{
			$(_pageId+" .fix_bot .ct_btn a").html("继续开户 >");  // 新开户
		}
		
		// 只有从 riskAssessment 跳转过来时，才设置页面的填充数据
		if(appUtils.getSStorageInfo("_prePageCode") == "account/riskAssessment")
		{
		
			var remark = appUtils.getPageParam("remark"); //风险等级
			var riskdesc = appUtils.getPageParam("riskdesc");  //风险等级类型
			showStr = riskdesc;
			var score = appUtils.getPageParam("score");//分数
			var investment_products = appUtils.getPageParam("investment_products");//投资产品
			var investment_term = appUtils.getPageParam("investment_term");//投资年限
			var investment_advice = appUtils.getPageParam("investment_advice");//购买建议
			
//			var rank = remark;
			// 清空原有内容
//			$(_pageId+" .test_result p:eq(0)").text("");
			$(_pageId+" .test_result1 em").text("");
//			$(_pageId+" .test_result p:eq(0)").text("您的投资风险等级为："+rank);
			$(_pageId+" .test_result1 em").append(showStr);
			$(_pageId+" #score").text(score);
			$(_pageId+" #investment_products").text(investment_products);
			$(_pageId+" #investment_term").text(investment_advice);
		}
		getAgreement();
	}
	
	/*获取协议*/
	function getAgreement(){
		service.queryProtocolList({"category_englishname":"riskprotcl"},function(data){
			if(data.error_no == 0 && data.results.length != 0){
				fristMap = new Map();
				var protocol = data.results;
				var allProtocols = "";
				var protocolMap = null;
				riskexp = appUtils.getPageParam("riskexp"); //风险等级级别
				lowestLevel = appUtils.getPageParam("lowestLevel");//保守型最低类别标识
				$(_pageId+" .mt15 #checked a:eq(2)").html("");
				for(i=0;i<protocol.length;i++){
					protocolMap = new Map();
	                protocolMap.put("protocolid",protocol[i].econtract_no);	//协议id
	                protocolMap.put("protocolname",protocol[i].econtract_name);	//协议名
	                protocolMap.put("summary",protocol[i].econtract_md5);	//协议内容MD5,签名摘要信息
					//allProtocols += "<a href=\"javascript:;\" protocol-id=\""+protocol[i].econtract_no+"\" id=\"protocol0"+i+"\">《"+
					//protocol[i].econtract_name+"》</a>";
					$(_pageId+" .mt15 #checked a:eq(0)").html("《"+protocol[0].econtract_name+"》");
					$(_pageId+" .mt15 #checked a:eq(1)").html("《"+protocol[1].econtract_name+"》");
					if(protocol[i].econtract_no == "800" || protocol[i].econtract_no == "801" || lowestLevel == "1"){
						fristMap.put(i,protocolMap);
					}else{
						if(riskexp == "11" || riskexp == "12"){
							$(_pageId+" .mt15 #checked a:eq(2)").html("《"+protocol[2].econtract_name+"》");
							fristMap.put(i,protocolMap);
						}
					}
					// 预绑定查看协议的事件
//					appUtils.preBindEvent($(_pageId+" #checked a"),function(e){
//					appUtils.preBindEvent($(_pageId+" #checked"),"#protocol0"+i,function(e){
//                        appUtils.pageInit("account/riskAssessmentResult","account/showProtocol",{"protocol_id" : $(this).attr("protocol-id")});
//                        e.stopPropagation();
//                    });
				}
//				$(_pageId+" .mt15 #checked").html(allProtocols);
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		},true,true,handleTimeout);
	}
	
	/* 处理请求超时 */
    function handleTimeout()
    {
        layerUtils.iConfirm("请求超时，是否重新加载？",function(){
        	getAgreement();  // 再次获取市场代码和协议
        });
    }
	
	function bindPageEvent()
	{
		/*勾选协议*/
		appUtils.bindEvent($(_pageId+" .mt15 span"),function(e){
			allIsShow = true;
			$(this).toggleClass("checked");
			if($(this).hasClass("checked")){
				numStr = ["800","801"];
				if(isshow){
					numStr.push("802");
				}
				console.log(numStr.length);
				//appUtils.setSStorageInfo("allIsShow",allIsShow);
				appUtils.pageInit("account/riskAssessmentResult","account/showProtocol",{"numStr":numStr,"allIsShow":allIsShow});
	            e.stopPropagation();
			}
		});
		
	  /* 绑定返回 */
        appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
            pageBack();
        });
		// 重新测评绑定事件
		appUtils.bindEvent($(_pageId+" .test_result p:eq(0) a"),function(){
			appUtils.pageInit("account/riskAssessmentResult","account/riskAssessment",{});
		});
		
		/**
		 * 9.1
		 * 风险测评结果页面进入问卷回访页面
		 */
		appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
			getSignProtocl_no();
		});
	}
	//查询回访问卷配置
    function isNeedConfirm(){
    	service.queryDataDict({"item_name" : "isNeedConfirm"},function(data){
            if(data.error_no == 0 )
            {
                var confirm = data.results;
                var isNeedConfirm = confirm.length != 0 && confirm[0].item_value ?　confirm[0].item_value : "1";
            	appUtils.setSStorageInfo("isNeedConfirm",isNeedConfirm);
            	if(isNeedConfirm == 0 ){
            	  //跳转到会访页面
            	   appUtils.pageInit("account/riskAssessmentResult","account/openConfirm",{});
            		
            	}else{
            	 //先判断是否进行过视频见证，没有见证跳到视频见证页面，见证过就跳到完成开户页面
                     queryQQOfflineState();
            	}	
            }
            else
            {
                layerUtils.iLoading(false);  // 关闭等待层。。。
                layerUtils.iAlert(data.error_info);
            }
        });
    	
    }
	
	  /* 查询离线视频通过状态 */
    function queryQQOfflineState()
    {
        var lookVedioStateParam = {
            "user_id" : appUtils.getSStorageInfo("user_id")
        };
        service.queryQQOfflineState(lookVedioStateParam,function(data){
            var error_no = data.error_no;
            var error_info = data.error_info;
            if(error_no == 0 && data.results.length != 0)
            {
                // 视频通过状态，0：未见证、2：已预约离线见证未完成见证、1：视频见证完成、3：见证失败
                // 未见证不需要做处理
                var witnessFlag = data.results[0].witness_flag;
                if(witnessFlag == 1) {
                    layerUtils.iAlert("您的审核已通过，请继续完成后续操作！",0 );
                        //若不需要安装证书，直接跳转到开户完成页面
                        appUtils.pageInit("account/riskAssessmentResult","account/accountResult",{});
                   
                } 
                else{
                    //其他值，表示没有通过视频见证，跳到视频见证页面
                    appUtils.pageInit("account/riskAssessmentResult","account/videoNotice",{});
                } 
            }
            else
            {
                layerUtils.iAlert(data.error_info); 
                 layerUtils.iLoading(false);
            }
        });
    }
	
	 /* 处理返回按钮 */
	function pageBack() {
		appUtils.pageInit("account/riskAssessmentResult", "account/riskAssessment", {});
	}
	
	function destroy(){
		protocolArray = [],  // 离开页面销毁签名值
	  	service.destroy();
	}
	
	/* 获取签名值 */
    function getSignProtocl_no()
    {
        var keys = fristMap.keys();  // 协议的数量
        
        // 检查是否勾选签署协议
        if($(_pageId+" .mt15 span").hasClass("checked"))
        {
            layerUtils.iLoading(true);  // 开启等待层。。。
            var oneData  = fristMap.get(keys[countProtocol]); // 取出一个协议
            var protocolid = oneData.get("protocolid"); // 协议ID
            var protocolname = oneData.get("protocolname");  //协议名称
            var summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
            // 添加值到数组中
            var protocol = {
                "protocol_id" : protocolid,
                "protocol_dcsign" : "",
                "summary" : summary
            };

            protocolArray.push(protocol);
            countProtocol++;
            if(countProtocol < keys.length)  // 通过比较，获取每个协议的签名值
            {
            
                getSignProtocl_no();
            }
            else  // 获取完每个签名值后 进行验签
            {
                startSign_no();
            }
        }
        else
        {
            layerUtils.iMsg(-1,"请阅读并勾选同意签署以上全部协议！");
            return false;
        }
    }

    /* 发请求进行协议验签 */
    function startSign_no()
    {
        countProtocol = 0;  // 将签署协议的计数器置为 0
        var signProtocolParam = {
            "user_id" : appUtils.getSStorageInfo("user_id"),
            "jsondata" : JSON.stringify(protocolArray),
            "ipaddr" : appUtils.getSStorageInfo("ip"),
            "macaddr" : appUtils.getSStorageInfo("mac"),
            "checksign":"0"
        };
        // 新开中登验签
        if(appUtils.getSStorageInfo("openChannel") == "new")
        {
            service.queryOpenCheckSign(signProtocolParam,callSign,false);
        }
        // 转户天威验签
        else if(appUtils.getSStorageInfo("openChannel") == "change")
        {
            service.queryOpenCheckTsign(signProtocolParam,callSign,false);
        }
    }

    /* 验签回调函数*/
    function callSign(data)
    {
        // 如果有一个协议签署失败，就将签署结果设为 false
        if(data.error_no == 0)
        {
        	//根据标识，判断是否需要回访问卷
 		   var isNeedConfirm =  appUtils.getSStorageInfo("isNeedConfirm");	
 		    if(isNeedConfirm == 0 )
             {	  //跳转到会访页面
             	appUtils.pageInit("account/riskAssessment","account/openConfirm",{});	
             }
             else{
             	 //先判断是否进行过视频见证，没有见证跳到视频见证页面，见证过就跳到完成开户页面
                  queryQQOfflineState();    
             }
        }
        else
        {
            layerUtils.iLoading(false);  // 关闭等待层。。。
            layerUtils.iAlert(data.error_info,-1);
        }
    }
	
	var riskAssessmentResult = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack":pageBack,
		"destroy" : destroy
	};
	
	module.exports = riskAssessmentResult;
});