	/**
	 * 开|转|理财户结果
	 */
	define("project/scripts/account/accountResult",function(require,exports,module){
		/* 私有业务模块的全局变量 begin */
		var appUtils = require("appUtils"),
			  gconfig = require("gconfig"),
			  layerUtils = require("layerUtils"),
			  utils = require("utils"),
			  validatorUtil = require("validatorUtil"),
			  global = gconfig.global,
			   startCountDown = null,
			  service = require("serviceImp").getInstance(),  //业务层接口，请求数据
			  _pageId = "#account_accountResult";
		/* 私有业务模块的全局变量 end */
		
		function init()
		{
		  //营销人员代码
		   	var recommendno = appUtils.getSStorageInfo("recommendno");
			if(recommendno){
	     		$(".recommendno", _pageId).val(recommendno);
			}
			initPage();
			
			//调用回访页面
			 if(appUtils.getSStorageInfo("_prePageCode")!= "account/finishConfirm"){ 
                  isNeedConfirm();
              }
              else{
                $(_pageId+" .order_succes h5:eq(0)").text("您已完成回访");
                $(_pageId+" .order_succes p:eq(0)").show();
		  		$(_pageId+" .order_succes p:eq(1)").show();
		  	//	$(_pageId+" .order_succes p:eq(1)").css("color","red"); 
              }	
		}
		
		function bindPageEvent()
		{  
		  //营销人员代码输入框长度判断
			appUtils.bindEvent( $(_pageId+" .order_info dl:eq(3) dd input"), function() {
			      var codeLength = $(this).val();
			      var recommendno = appUtils.getSStorageInfo("recommendno");
			     if(!$(this).val().length==6 || !$(this).val().length==8){
			     	$(_pageId+" .order_info .ct_btn1 a").text("提交");
			     }else if($(this).val()!=recommendno || !($(this).val().length==6 || $(this).val().length==8)){
			      	 $(_pageId+" .order_info .ct_btn1 a").text("修改");
			      }else{
			      	 $(_pageId+" .order_info .ct_btn1 a").text("提交");
			      }
			      
				  if(!$(_pageId+" .recommendno").attr("readonly")){
			         if (!validatorUtil.isAlphaNumeric(codeLength) || !(codeLength.length == 6 || codeLength.length == 8)) {
						layerUtils.iMsg(-1, "请输入6位或8位营销人员代码");
						$(_pageId+" .order_info .ct_btn1 a").text("提交");
						$(this).val("");
						return false; 
				     }  
			      }
			},"blur");
			appUtils.bindEvent( $(_pageId+" .order_info dl:eq(3) dd input"), function() {
			      
			      	 $(_pageId+" .order_info .ct_btn1 a").text("提交");
			     
			},"focus");
					
				/* 限制营销人员代码长度 */
			appUtils.bindEvent($(_pageId+" .order_info dl:eq(3) dd input"), function() {
				utils.dealIPhoneMaxLength(this, 8); //处理iphone兼容
			}, "input");
			
			//提交营销人员代码
			appUtils.bindEvent($(_pageId+" .order_info .ct_btn1 a"), function() {
				var codeLength = $(_pageId+" .order_info dl:eq(3) dd input").val();
				if(!$(_pageId+" .recommendno").attr("readonly")){
			         if (!validatorUtil.isAlphaNumeric(codeLength) || !(codeLength.length == 6 || codeLength.length == 8)) {
						layerUtils.iMsg(-1, "请输入6位或8位营销人员代码");
						$(_pageId+" .order_info .ct_btn1 a").text("提交");
						$(this).val("");
						return false; 
				     }  
			      }
				//营销人员代码	
				var Param = {
				    "user_id" : appUtils.getSStorageInfo("user_id")
				}
							
				//显示和修改营销人员代码
				 service.alterRecommendno(Param,function(data){
					if(data.error_no == 1 )
					{
					   var fund_account = appUtils.getSStorageInfo("fund_account"); // 资金账号
						if(fund_account){
						    appUtils.getSStorageInfo("recommendno");
				             $(".recommendno", _pageId).val(recommendno);
						     $(".recommendno", _pageId).attr("readonly", "readonly");
					         $( _pageId+" .ct_btn1").css("display","none");
						 }
						 else{
							 //提交营销人员代码
							 appUtils.bindEvent( $(_pageId+" .order_info .ct_btn1"), function() {
						   //提交营销人员代码提交接口
							submitRecommendno();
						     })
				         }       
					  }
					  else if(data.error_no == 2)
					  {
					      //不可以修改，提交按钮隐藏
					    $(".recommendno", _pageId).attr("readonly", "readonly");
					    $(_pageId+" .ct_btn1").css("display","none");
					               
					  }
				});
			
			});

					
			/* 交易软件下载  */
			appUtils.bindEvent($(_pageId+" .tradeAppDown:eq(0) a"),function(){
			
				var url = {
					"url" : gconfig.platform === "2" ?
						"https://itunes.apple.com/cn/app/yin-tai-zhang-yi-bao/id1080275337?mt=8" :
						"http://wap.ytzq.com/upload/software/ytzzgp.apk"

				};	
				require("shellPlugin").callShellMethod("webViewPlugin",null,null,url);
			});
		}
		
		function destroy() {
			 if(startCountDown != null)
	        {
	            window.clearInterval(startCountDown);
	        }
	        $(_pageId+" .time").hide(); 
			$(_pageId+" order_succes p:eq(4)").html("");
			$(_pageId+" #gdzh").html("");
			appUtils.clearSStorage();  // 清空所有的session
			
		}
		
	    /* 初始化页面 */	
		function initPage()
		{  
		   
		    $(_pageId+" .header h3").html("开户结果");
			$(_pageId+" .order_succes h5:eq(0)").text("开户申请提交成功！");
			$(_pageId+" .order_succes p:eq(0)").html("您的开户申请我们已经收到并正在受理中。");
			$(_pageId+" .order_succes p:eq(1)").html("回访成功后我们在一个交易日内审核您的开户请求，短信告知您的账户开立结果。");		
					
					// 驳回后重新提交
					if(appUtils.getSStorageInfo("isBack") == "backInfo")
					{
						$(_pageId+" .header h3").html("开户进度");
						$(_pageId+" .order_succes h5:eq(0)").text("重新提交资料成功！");
					}
		//			$(_pageId+" .order_succes p:eq(0)").hide();  
		//			$(_pageId+" .order_succes p:eq(1)").hide();	
		      
					queryAccount(); // 查询用户信息
				
		}
		
		
	
		
		/* 查询用户信息 */
		function queryAccount()
		{
			var param = {"user_id" : appUtils.getSStorageInfo("user_id")};
			service.queryUserInfo(param, function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == 0)
				{
					var res = data.results[0];
					appUtils.setSStorageInfo("back_step",res.back_step);  // 回访状态
					appUtils.setSStorageInfo("fund_account",res.fund_account);  // 资金账号
					appUtils.setSStorageInfo("szaselect",res.szaselect); // 深A状态
					appUtils.setSStorageInfo("shaselect",res.shaselect); // 沪A状态
					appUtils.setSStorageInfo("szaaccount",res.szaaccount); // 深A账号
					appUtils.setSStorageInfo("shaaccount",res.shaaccount); // 沪A账号
					appUtils.setSStorageInfo("commission",res.commiss); // 佣金展示
					
					
					showOpenAccount();  // 显示开户结果
				}
				else
				{
					layerUtils.iMsg(-1, error_info);
				}
			});
		}
		
	 /* 延迟3秒显示 */
    function visitSuccess()
    {
            layerUtils.iLoading(false);
            //若需要回访，跳转到回访页面，否则还在开户完成页面
        appUtils.pageInit("account/accountResult","account/finishConfirm");
      
    }
    
	//回访问卷开关
		function isNeedConfirm(){
	        var submitParam = {
				"user_id" : appUtils.getSStorageInfo("user_id")
			}
			service.accountSwitch(submitParam,function(data){
	            if(data.error_no == 1 ){
	            	//倒计时3秒调用回访问卷
	             	countDown();	
	            }else{
	              $(_pageId+" .order_succes p:eq(0)").show();
			  	  $(_pageId+" .order_succes p:eq(1)").show();
	            }	
	            layerUtils.iLoading(false);  // 关闭等待层。。。
          	},false,true,handleTimeout);
         }
		//超时重新调用接口
		function handleTimeout(){
		// layerUtils.iConfirm("请求超时，是否重新加载？",function(){
		     console.log("sd");
			 isNeedConfirm(); // 再次调用回访问卷
		//});
		 
		}
		            	
		function countDown(){
			// 显示倒计时
            $(_pageId+" .order_succes p:eq(0)").hide();
			$(_pageId+" .order_succes p:eq(1)").hide();
            $(_pageId+" .time").show();
            $(_pageId+" .info").show();
		    //倒计时显示
              var sumTime = 3;
                //处理获取验证码时发生的动作
               startCountDown = window.setInterval(function(){
                    $(_pageId+" .time").text("您的开户申请我们已经收到，系统将在"+sumTime--+"秒后对您进行问卷回访");
                	if(sumTime <=0){
                		// 隐藏倒计时
	                    $(_pageId+" .time").hide();
	                    $(_pageId+" .info").hide();
	                    $(_pageId+" .order_succes p:eq(0)").show();
						$(_pageId+" .order_succes p:eq(1)").show();
	                    window.clearInterval(startCountDown);
	                    appUtils.pageInit("account/accountResult","account/finishConfirm");
                	}
                }, 1000);
		}
		   
		   
		   
		/* 显示新开户结果 */
		function showOpenAccount()
		{
			// 从 session 中取资金账号和股东账号
			var  back_step = appUtils.getSStorageInfo("back_step"),  // 回访状态
				 shaselect = appUtils.getSStorageInfo("shaselect"),  // 是否选择沪A
				 szaselect = appUtils.getSStorageInfo("szaselect"),  // 是否选择深A
			     fund_account = appUtils.getSStorageInfo("fund_account"),  // 资金账号
				 shaaccount = appUtils.getSStorageInfo("shaaccount"), // 沪A股东账户
				 szaaccount = appUtils.getSStorageInfo("szaaccount");  // 深A股东账户
				 recommendno = appUtils.getSStorageInfo("recommendno");//营销人员代码
				 commission =  appUtils.getSStorageInfo("commission");//佣金率
				  
				 //设置按钮显示提示文字
			  
				if("o" == back_step){
						// 判断资金账户是否开出
					if(fund_account)
					{  
						//设置按钮显示提示文字
						if(appUtils.getSStorageInfo("openChannel") == "change")
						{
							if(appUtils.getSStorageInfo("finance") == "finance")
							{
								$(_pageId+" .order_succes h5:eq(0)").text("恭喜开户成功！");
								$(_pageId+" .commis_show").show();
								$(_pageId+" .commission").html(commission+"‰");
							}else{
								$(_pageId+" .order_succes h5:eq(0)").text("恭喜转户成功！");
							}
						}else{
							$(_pageId+" .order_succes h5:eq(0)").text("恭喜开户成功！");
							$(_pageId+" .commis_show").show();
							$(_pageId+" .commission").html(commission+"‰");
						}
					// 显示资金账户、股东账号的信息
					$(_pageId+" #zjzh").html("<a href='javascript:void(0)' class='copy'>复制账号</a>&nbsp;"+fund_account);
					$(_pageId+" #zjzh").html(fund_account);
				}else{
					$(_pageId+" .order_succes p:eq(0)").show();
					$(_pageId+" .order_succes p:eq(1)").show();
					$(_pageId+" #zjzh").html("&nbsp;处理中...");
				}
				if(szaselect == null)
				{
					$(_pageId+" .order_info dl:eq(1) dd").html("&nbsp;未申请");
					$(_pageId+" .order_info dl:eq(1)").hide();
				}
				// 未开通沪A
				if(shaselect == null)
				{
					$(_pageId+" .order_info dl:eq(2) dd").html("&nbsp;未申请");
					$(_pageId+" .order_info dl:eq(2)").hide();
				}
				// 开通了深A
				if(szaselect != null)
				{
					// 深A已经开出账号
					if(szaaccount != null)
					{
					//	$(_pageId+" .order_succes p:eq(0)").hide();
					//	$(_pageId+" .order_succes p:eq(1)").hide();
						appUtils.getSStorageInfo("recommendno", recommendno);
			            $(".recommendno", _pageId).val(recommendno);
						$(_pageId+" .order_info dl:eq(1) dd").html("&nbsp;"+szaaccount);
					}
					else
					{
					//	$(_pageId+" .order_succes p:eq(0)").show();
					//	$(_pageId+" .order_succes p:eq(1)").show();
						$(_pageId+" .order_info dl:eq(1) dd").html("&nbsp;处理中...");
					}
				}
				// 开通了沪A
				if(shaselect != null)
				{
					// 沪A已经开出账号
					if(shaaccount != null)
					{
						$(_pageId+" .order_info dl:eq(2) dd").html("&nbsp;"+shaaccount);
					//	$(_pageId+" .order_succes p:eq(0)").hide();
					//	$(_pageId+" .order_succes p:eq(1)").hide();
					}
					else
					{
					//	$(_pageId+" .order_succes p:eq(0)").show();
					//	$(_pageId+" .order_succes p:eq(1)").show();
						$(_pageId+" .order_info dl:eq(2) dd").html("&nbsp;处理中...");
					}
				}
		}else{
			$(_pageId+" #zjzh").html("&nbsp;处理中...");
			$(_pageId+" .order_info dl:eq(1) dd").html("&nbsp;处理中...");
			$(_pageId+" .order_info dl:eq(2) dd").html("&nbsp;处理中...");
		}
			// 未开通深A
			
			// 如果开出了上海账号，显示提示信息
			if(($(_pageId+" .order_info").html()).indexOf("沪") != -1)
			{
				$(_pageId+" .order_succes p:eq(4)").html("注意：请登录交易系统进行上海账户的指定交易：点击\"买入\"，输入证券代码\"799999\"，价格\"1\"，股数\"1\"。");
			}
	
		else{
			$(_pageId+" #zjzh").html("&nbsp;处理中...");
			$(_pageId+" .order_info dl:eq(1) dd").html("&nbsp;处理中...");
			$(_pageId+" .order_info dl:eq(2) dd").html("&nbsp;处理中...");
		}
	}
		
		//提交营销人员代码
		function submitRecommendno(){
		
		    var Param = {
							"user_id" : appUtils.getSStorageInfo("user_id"),
							"recommendno" : $(".recommendno", _pageId).val().trim()//营销人员代码
					   }
			 service.submitRecommendno(Param,function(data){
				
				var recommendno = $(".recommendno", _pageId).val().trim();
			    appUtils.setSStorageInfo("recommendno", recommendno);
			    $(".recommendno", _pageId).val(recommendno);
			    if(recommendno !== "" && !validatorUtil.isNumeric(recommendno)){
					layerUtils.iMsg(-1,"营销人员代码必须为数字");
					return false;
				}
				 else{
					  layerUtils.iAlert("提交成功");
					  layerUtils.iLoading(false);   
//					  $(_pageId+" .order_info .ct_btn1").text("修改");        
					}

		
		})
		
	}	
		var accountResult = {
			"init" : init,
			"bindPageEvent" : bindPageEvent,
			"destroy" : destroy
		};
		
		module.exports = accountResult;
	});
	
	
	