/**
* 查看协议
*/
define("project/scripts/account/showProtocol",function(require,exports,module){
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		numStr1 = [],
		_pageId = "#account_showProtocol";
	
	function init(){
		// 清除原有数据
		$(_pageId+" #contenttxt").text("");
		$(_pageId+" .top_title p:eq(0)").text("");
		//设置按钮显示提示文字
		if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			$(_pageId+" .fix_bot .ct_btn a").html("确定 >");
		}else
		{
			$(_pageId+" .fix_bot .ct_btn a").html("确定 >");
		}
		var allIsShow = appUtils.getPageParam("allIsShow");
		var numStr = appUtils.getPageParam("numStr");
		var user_id = appUtils.getSStorageInfo("user_id");
//		console.log(numStr.length);
		if(allIsShow){
			showProtocols(0,numStr.length,numStr);
			/*for(var i=0;i<numStr.length;i++){
				var protocol_id = numStr[i];
			
			//查询协议内容
			service.getProtocolInfo({"econtract_no":protocol_id,"user_id":user_id},function(data){
				if(error_no = data.error_no)
				{
					$(_pageId+" .top_title p:eq(0)").text(data.results[0].econtract_brief);
					$(_pageId+" #contenttxt").append(data.results[0].econtract_content);
				}
				else
				{
					layerUtils.iMsg(-1, data.error_info);
				}
			});
			}*/
		}else{
			var protocol_id = appUtils.getPageParam("protocol_id");
			var param = {
				"econtract_no" : protocol_id,
				"user_id" : user_id,
				"econtract_version":""
			}
			//查询协议内容
			service.getProtocolInfo(param,function(data){
				if(error_no = data.error_no)
				{
					$(_pageId+" .top_title p:eq(0)").text(data.results[0].econtract_name);
					$(_pageId+" #contenttxt").append(data.results[0].econtract_content);
				}
				else
				{
					layerUtils.iMsg(-1, data.error_info);
				}
			});
		}
	}
	
	function showProtocols(num,total,protocol_nos){
		var user_id = appUtils.getSStorageInfo("user_id");
		if(num < total){
			service.getProtocolInfo({"econtract_no":protocol_nos[num],"user_id":user_id},function(data){
				if(error_no = data.error_no){
					$(_pageId+" .top_title p:eq(0)").text(data.results[0].econtract_brief);
					$(_pageId+" #contenttxt").append(data.results[0].econtract_content);
				}else{
					layerUtils.iMsg(-1, data.error_info);
				}
				showProtocols(num+1,total,protocol_nos)
			});
		}
	}
	
	function bindPageEvent(){
		
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
		
		// 绑定继续开户
		appUtils.bindEvent($(_pageId+" .ct_btn a"),function(){
			appUtils.pageBack();
		});
	}
	function destroy(){
		// 将协议内容置空
		$(_pageId+" #contenttxt").text("");
		$(_pageId+" .top_title p:eq(0)").text("");
		service.destroy();
	}
	
	var showProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = showProtocol;
});